Add another note about libdvdcss
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.2
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # See the README file for information about the dependencies
19 # this script has.
20
21 ##############################################################################################
22 # Global Variables
23 ##############################################################################################
24 typeset cmd="$0 $*"
25 typeset dvdname=""
26 typeset debug=""
27 typeset dest=""
28 typeset isofile=""
29 typeset vobfile=""
30 typeset dvdpath=""
31 typeset aspect=""
32 typeset SCALE=""
33 typeset CROP=""
34 typeset profile="xvidhq"
35 typeset extension=""
36 typeset mailto=""
37 typeset encoder=""
38 typeset default_alang="en"
39 typeset track=""
40 typeset drc="0.0"
41 typeset -i default_aid=128
42 typeset -i aid_override=-1
43 typeset -i force_onepass_mode=0
44 typeset -i eject_disk=1
45 typeset -i keep_isofile=0
46 typeset -i keep_vobfile=0
47 typeset -i keep_dvdfolder=0
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_comp=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_bitrate=2000
57 typeset -i target_size=0
58 typeset -i audio_2ch=0
59 typeset -i audio_6ch=1
60 typeset -i invalid_feature_title=0
61 typeset -i feature_title_override=0
62 typeset -i mplayer_dumpstream_incompatibility=0
63 typeset -i custom_bitrate=0
64 typeset -i custom_audio_2ch=0
65 typeset -i custom_audio_6ch=0
66
67 ##############################################################################
68 # Local Machine Settings:
69 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
70 # and the local conf file created by each local machine (rip_dvd.conf)
71 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
72 # This will allow you to override all the default values to meet your needs
73 # in a way that won't get clobbered when you pull updates from my GIT repo.
74 ##############################################################################
75 config="${0%/*}/rip_dvd.conf"
76
77 # The config file will be searched for in the following location order:
78 found_config=0
79
80 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
81 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
82
83 # 2) /path/to/rip_dvd/script/rip_dvd.conf
84 [ -e "${config}" ] && found_config=1 && . "${config}"
85
86 # 3) /etc/rip_dvd.conf
87 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
88
89 # 4) $PWD/rip_dvd.conf
90 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
91
92 # Check to make sure we found the config file
93 if [ $found_config -eq 0 ]; then
94   echo "-E- Unable to find the rip_dvd.conf file: $config"
95   exit 1
96 fi
97
98 ##############################################################################################
99 # Command line processing
100 ##############################################################################################
101 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
102 do
103     case $opt in
104         (n)     dvdname=$OPTARG;;
105         (d)     dest=$OPTARG;;
106         (b)     target_bitrate=$OPTARG; custom_bitrate=1;;
107         (s)     target_size=$OPTARG;;
108         (2)     audio_2ch=1; custom_audio_2ch=1;;
109         (6)     audio_6ch=1; custom_audio_6ch=1;;
110         (1)     force_onepass_mode=1;;
111         (v)     make_final_dest_vob=1;;
112         (i)     make_final_dest_iso=1;;
113         (f)     make_final_dest_folder=1;; 
114         (z)     make_final_dest_comp=1;;
115         (e)     encoder=$OPTARG;;
116         (m)     mirror_mode=1;;
117         (k)     keep_intermediate_files=1;;
118         (t)     feature_title_override=$OPTARG;;
119         (a)     aspect=$OPTARG;;
120         (p)     profile=$OPTARG;;
121         (x)     extension=$OPTARG;;
122         (j)     eject_disk=$OPTARG;;
123         (l)     aid_override=$OPTARG;;
124         (r)     drc=$OPTARG;;
125         (w)     set -x;;
126         (h)     show_usage=1;;
127         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
128         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
129     esac
130 done
131
132 shift $((OPTIND-1))
133
134 function usage() {
135     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
136     echo >&2 "Revision $REV"
137     echo >&2 "Options:"
138     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
139     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
140     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
141     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
142     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
143     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
144     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
145     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
146     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
147     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
148     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
149     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
150     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
151     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
152     echo >&2 "                 Handbrake Only Encoder Profiles:"
153     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
154     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
155     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
156     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
157     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
158     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
159     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
160     echo >&2 "                 The default operation is non-mirror mode where only the main"
161     echo >&2 "                 feature title will be ripped."
162     echo >&2 "   -v            Make the final image a DVD VOB file"
163     echo >&2 "   -i            Make the final image a DVD ISO file"
164     echo >&2 "   -f            Make the final image a DVD folder"
165     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
166     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
167     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
168     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
169     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
170     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
171     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
172     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
173     echo >&2 "   -j <n>        Eject the disk:"
174     echo >&2 "                 - 0 = do not eject the disk"
175     echo >&2 "                 - 1 = eject after the entire script is done (default)"
176     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
177     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
178     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
179     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
180     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
181     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
182     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
183     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
184     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
185     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
186     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
187     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
188     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
189     echo >&2 ""
190     exit 2
191 }
192
193 if (($errors)) || (($show_usage))
194 then
195   usage
196 fi
197
198 # Sanity Check - Command Line Options 
199 if [ "$dest" == "" ]; then
200   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
201   usage
202 fi
203
204 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
205    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
206     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
207     make_final_dest_comp=1
208 fi
209
210 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
211   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
212   usage
213 fi
214
215 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
216   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
217   usage
218 fi
219
220 if [ $mirror_mode -eq 1 ]; then
221   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
222      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
223     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
224     usage
225   fi
226 fi
227
228 # Make handbrake the default encoder if not specified and we can find it
229 if [ -z "$encoder" ]; then
230   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
231   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
232   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
233   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
234   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
235 fi
236
237 # Sanity check the profile selection
238 if [[ "$encoder" == "mencoder" ]]; then
239   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
240 fi
241
242 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
243   echo "-E- Invalid encoder specified: $encoder"
244   exit 1
245 fi
246
247 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
248 if [ "$aspect" != "" ]; then
249   echo "$aspect" | grep -q "x"
250   if [ $? == 0 ]; then
251     echo "-E- You must specify the aspect option with a value whose format is W:H"
252     exit 1
253   fi
254   echo "$aspect" | grep -q ":"
255   if [ $? != 0 ]; then
256     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
257     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
258   else
259     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
260     if [ "$encoder" == "handbrake" ]; then
261        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
262        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
263        SCALE="-w $WIDTH -l $HEIGHT"
264     fi
265   fi
266 fi
267
268 # Sanity Check - Key executables
269 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
270 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
271 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
272 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
273 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
274 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
275 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
276 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
277 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
278 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
279 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
280 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
281 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
282
283 ##############################################################################################
284
285 typeset -i ripdvd
286 if [ -z "$dvdname" ]; then
287
288   # make sure the DVD device is accessible
289   volname $dev > /dev/null 2>&1
290   if [ $? != 0 ]; then
291     echo "-E- Can't access the DVD device $dev"
292     exit 1
293   fi
294   # now capture the volume name from the device
295   dvdname=`volname $dev | awk '{ print $1 }'`
296   ripdvd=1
297
298 else 
299
300   # check to see if dvdname is a full path to a real directory
301   # if it is, set dvdname and dvdpath appropriately
302   if [ -d "$dvdname" ]; then
303     dvdpath="$dvdname"
304     dvdname=`basename "$dvdname"`
305     keep_dvdfolder=1
306     if [ -z "$dvdname" ]; then
307      echo "-E- Unable to extract dvdname from path: $dvdpath"
308      exit 1
309     fi
310     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
311       echo "-E- You must supply a full path to a valid DVD folder with this option"
312       exit 1
313     fi
314   fi
315
316   # Check to see if dvdname is a full path to a file
317   if [ -f "$dvdname" ]; then
318     valid_file=0
319
320     # check to see if dvdname is a full path to an MPG2 (VOB) file
321     # if it is, set dvdname and vobfile appropriately
322     file "$dvdname" | grep -q "MPEG"
323     if [ $? == 0 ]; then
324       # It is a valid MPEG2 file, now strip the extension off our dvdname
325       vobfile="$dvdname"
326       dvdname=`basename "$dvdname"`
327       dvdname=${dvdname%.[^.]*}
328       keep_vobfile=1
329       valid_file=1
330     fi
331
332     # check to see if dvdname is a full path to an ISO file
333     # if it is, set dvdname and isofile appropriately
334     file "$dvdname" | grep -q -e "ISO" -e "UDF"
335     if [ $? == 0 ]; then
336       # It is a valid ISO file, now strip the extension off our dvdname
337       isofile="$dvdname"
338       dvdname=`basename "$dvdname"`
339       dvdname=${dvdname%.[^.]*}
340       keep_isofile=1
341       valid_file=1
342     fi    
343
344     # check to see if dvdname is a full path to an ISO file
345     # if it is, set dvdname and isofile appropriately
346     file "$dvdname" | grep -q -e "VOB"
347     if [ $? == 0 ]; then
348       # It is a valid VOB file, now strip the extension off our dvdname
349       vobfile="$dvdname"
350       dvdname=`basename "$dvdname"`
351       dvdname=${dvdname%.[^.]*}
352       keep_vobfile=1
353       valid_file=1
354     fi    
355
356     # If we didn't find a handler for the file above, complain
357     if [ $valid_file -eq 0 ]; then
358       echo "-E- Unsupported file type: $vobfile"
359       exit 1
360     fi
361
362   # Throw an error if we can't find what the -n option is pointing to
363   else 
364     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
365     exit 1
366   fi
367
368   # Set the ripdvd flag to false since we aren't ripping a DVD disk
369   ripdvd=0
370
371   # Since we aren't ripping a DVD disk, don't eject anything either
372   eject_disk=0
373
374 fi
375
376 # remove bad characters from the dvdname
377 dvdname=${dvdname%.} # remove trailing '.' character
378
379 # add the suffix extension to the end of the dvdname
380 dvdname=$dvdname$extension
381
382 # make a "safe" dvdname (remove special characters)
383 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
384
385 # Make sure we have a non-empty dvdname
386 if [ -z "$dvdname" ]; then
387   echo "-E- unable to determine dvdname"
388   exit 1
389 fi
390
391 # make sure our vobfile value is set
392 if [ -z "$vobfile" ]; then
393   vobfile="$dest/$dvdname.VOB"
394 fi
395
396 # set up some variables to hold various logfiles
397 logfile="$logdir/$dvdname.log"
398 passlogfile="$tmpdir/$safedvdname.log"
399 ddrescuelog=`tempfile`
400 dvdauthorlog=`tempfile`
401 encodelog=`tempfile`
402 dumplog=`tempfile`
403
404 # create the tmpdir if it doesn't already exist
405 if [ ! -d "$tmpdir" ]; then
406   mkdir -p "$tmpdir"
407   if [ $? != 0 ]; then
408     echo "-E- Unable to create the tmpdir: $tmpdir"
409     exit 1
410   fi
411 fi
412
413 # create the logdir if it doesn't already exist
414 if [ ! -d "$logdir" ]; then
415   mkdir -p "$logdir"
416   if [ $? != 0 ]; then
417     echo "-E- Unable to create the logdir: $logdir"
418     exit 1
419   fi
420 fi
421
422 ##############################################################################################
423 # cleanup functions
424 ##############################################################################################
425 cleanup() { 
426   if [ $keep_intermediate_files -eq 0 ]; then
427     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
428     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
429     [[ -e "$encodelog" ]] && rm -f "$encodelog"
430     [[ -e "$dumplog" ]] && rm -f "$dumplog"
431   else
432     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
433     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
434     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
435     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
436   fi
437   echo ""
438 }
439
440 fatal_and_exit() {
441   if [[ -z "$1" ]]; then
442     msg="-E- control-c killed us"
443   else
444     msg=$1
445   fi
446   echo -e 2>&1 "$msg" | tee -a "$logfile"
447   if [[ -n "$mailto" ]]; then
448     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
449   fi
450   keep_intermediate_files=1
451   exit 1
452 }
453
454 # Call our cleanup functions on INT and EXIT signals
455 trap fatal_and_exit INT
456 trap cleanup EXIT
457
458 ##############################################################################################
459 # processing functions
460 ##############################################################################################
461
462 # encode the vob file into a compressed file format using handbrake
463 function encode_vob_file_handbrake {
464   
465   # declare some globals
466   typeset handbrake_cli=""
467   typeset handbrake_video_encoder_opts=""
468   typeset filetype=""
469   typeset handbrake_audio_opts=""
470   typeset hb_profile=""
471   typeset SIZE=""
472
473   # Set a variable that we will use later to determine if we found a handler for $profile or not
474   typeset -i found_profile=0    
475
476   # For a given profile, to override the 2 pass behavior to be single pass,
477   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
478   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
479   PASSES="-2"
480
481   # Set our DRC option
482   DRC="-D $drc"
483
484   if [ $target_size -ne 0 ]; then
485     SIZE="-S $target_size"
486   fi 
487
488   # Check the global force_onepass_mode. If it is set, change our variables appropriately
489   # to force 1-pass encoding across all profiles.
490   if [ $force_onepass_mode -eq 1 ]; then
491     PASSES=""
492   fi
493
494   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
495   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
496
497   # XVID profile
498   if [[ "$profile" =~ "xvid" ]]; then
499     found_profile=1
500     handbrake_cli="$handbrake_xvid"
501     final_output_file="$dest/$dvdname.avi"
502     filetype="avi"
503
504     # Very High Quality (16fps)
505     if [ "$profile" == "xvidvhq" ]; then
506       handbrake_opts[0]="-f avi"
507       handbrake_opts[1]="-b $target_bitrate"
508       handbrake_opts[2]="-e xvid"
509       handbrake_opts[3]="-T"
510       handbrake_opts[4]="-5"
511       handbrake_opts[5]="-8"
512     fi
513     # High Quality (20fps)
514     if [ "$profile" == "xvidhq" ]; then
515       handbrake_opts[0]="-f avi"
516       handbrake_opts[1]="-b $target_bitrate"
517       handbrake_opts[2]="-e ffmpeg"
518       handbrake_opts[3]="-T"
519       handbrake_opts[4]="-5"
520     fi
521     # Fast (28fps)
522     if [ "$profile" == "xvid" ]; then
523       handbrake_opts[0]="-f avi"
524       handbrake_opts[1]="-b $target_bitrate"
525       handbrake_opts[2]="-e ffmpeg"
526       handbrake_opts[3]="-T"
527     fi
528   fi
529
530   # MP4 profile
531   if [[ "$profile" =~ "mp4" ]]; then
532     found_profile=1
533     handbrake_cli="$handbrake_mp4"
534     final_output_file="$dest/$dvdname.mp4"
535     PASSES=""
536
537     # Handle custom parameter overrides
538     if [ $custom_bitrate == 1 ]; then
539       handbrake_opts[0]="-b $target_bitrate"
540     fi
541     if [ $custom_audio_2ch == 0 ]; then
542       audio_2ch=0
543     fi
544     if [ $custom_audio_6ch == 0 ]; then
545       audio_6ch=0
546     fi
547
548     # Very High Quality
549     if [ "$profile" == "mp4vhq" ]; then
550       profile="hb_High_Profile"
551     fi
552     # High Quality
553     if [ "$profile" == "mp4hq" ]; then
554       profile="hb_Normal"
555     fi
556     # Fast
557     if [ "$profile" == "mp4" ]; then
558       profile="hb_Classic"
559     fi
560   fi
561
562   # iphone and ipod MP4 profiles
563   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
564     found_profile=1
565     handbrake_cli="$handbrake_mp4"
566     final_output_file="$dest/$dvdname.mp4"
567     PASSES=""
568
569     # Handle custom parameter overrides
570     if [ $custom_bitrate == 1 ]; then
571       handbrake_opts[0]="-b $target_bitrate"
572     fi
573     if [ $custom_audio_2ch == 0 ]; then
574       audio_2ch=0
575     fi
576     if [ $custom_audio_6ch == 0 ]; then
577       audio_6ch=0
578     fi
579
580     # iphone
581     if [ "$profile" == "iphone" ]; then
582       profile="hb_iPhone_&_iPod_Touch"
583     fi
584     # ipod
585     if [ "$profile" == "ipod" ]; then
586       profile="hb_iPod"
587     fi
588
589   fi
590   
591   # Predefined Handbrake Profile Handling
592   if [[ "$profile" =~ "hb" ]]; then
593     found_profile=1
594     handbrake_cli="$handbrake_mp4"
595     final_output_file="$dest/$dvdname.mp4"
596     PASSES=""
597
598     # Handle custom parameter overrides
599     if [ $custom_bitrate == 1 ]; then
600       handbrake_opts[0]="-b $target_bitrate"
601     fi
602     if [ $custom_audio_2ch == 0 ]; then
603       audio_2ch=0
604     fi
605     if [ $custom_audio_6ch == 0 ]; then
606       audio_6ch=0
607     fi
608     
609     # extract the HandBrake Profile name from $profile
610     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
611   fi
612
613   # Make sure we found a handler for the given profile
614   if [ $found_profile -eq 0 ]; then
615     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
616   fi
617
618   # setup our audio option
619   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
620     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
621   fi
622   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
623     handbrake_audio_opts="-E ac3 -6 auto"
624   fi
625   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
626     handbrake_audio_opts="-E faac -6 dpl2"
627   fi
628   if [ -n "$track" ]; then
629     handbrake_audio_opts="$handbrake_audio_opts -a $track"
630   fi
631
632   # Convert our array of opts into a string
633   for OPTS in "${video_encoder_opts[@]}"; do 
634     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
635   done
636   if [ -n "$handbrake_video_encoder_opts" ]; then
637     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
638   fi
639   for OPTS in "${handbrake_opts[@]}"; do 
640     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
641   done
642
643   # Append "global" command line options
644   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
645   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
646   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
647   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
648   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
649
650   # Execute the handbrake command to encode the video
651   if [ -n "$hb_profile" ]; then
652     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
653     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
654     handbrake_retval=$?
655   else 
656     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
657     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
658     handbrake_retval=$?
659   fi
660   if [ $handbrake_retval != 0 ]; then
661     fatal_and_exit "-E- Unhandled handbrake error"
662   fi
663
664   # Concatenate the encode log to our main log file, greping out unwanted lines
665   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
666   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
667   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
668 }
669
670 # encode the vob file into a compressed file format using mencoder
671 function encode_vob_file_mencoder {
672
673   # Set a variable that we will use later to determine if we found a handler for $profile or not
674   typeset -i found_profile=0
675
676   # For a given profile, to override the 2 pass behavior to be single pass,
677   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
678   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
679   PASSES="1 2"
680
681   # Declare our default 2 pass variables
682   passlogfile_opt="-passlogfile $passlogfile"
683   pass_opt="pass=%PASS"
684
685   # Check the global force_onepass_mode. If it is set, change our variables appropriately
686   # to force 1-pass encoding across all profiles.
687   if [ $force_onepass_mode -eq 1 ]; then
688     PASSES="2"
689     passlogfile_opt=""
690     pass_opt=""    
691   fi
692
693   # XVID profile
694   if [[ "$profile" =~ "xvid" ]]; then
695     found_profile=1
696     final_output_file="$dest/$dvdname.avi"
697     mencoder_general_opts="$lang_opts $passlogfile_opt"
698     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
699     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
700     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
701
702     # Very High Quality (16fps)
703     if [ "$profile" == "xvidvhq" ]; then
704       video_encoder_opts[0]="bitrate=$target_bitrate"
705       video_encoder_opts[1]="threads=$mencoder_threads"
706       video_encoder_opts[2]="chroma_opt"
707       video_encoder_opts[3]="vhq=4"
708       video_encoder_opts[4]="bvhq=1"
709       video_encoder_opts[5]="quant_type=mpeg"
710       video_encoder_opts[6]="autoaspect"
711     fi
712     # High Quality (20fps)
713     if [ "$profile" == "xvidhq" ]; then
714       video_encoder_opts[0]="bitrate=$target_bitrate"
715       video_encoder_opts[1]="threads=$mencoder_threads"
716       video_encoder_opts[2]="chroma_opt"
717       video_encoder_opts[3]="vhq=2"
718       video_encoder_opts[4]="bvhq=1"
719       video_encoder_opts[5]="quant_type=mpeg"
720       video_encoder_opts[6]="autoaspect"
721     fi
722     # Fast (28fps)
723     if [ "$profile" == "xvid" ]; then
724       video_encoder_opts[0]="bitrate=$target_bitrate"
725       video_encoder_opts[1]="threads=$mencoder_threads"
726       video_encoder_opts[2]="vhq=0"
727       video_encoder_opts[3]="turbo"
728       video_encoder_opts[4]="autoaspect"
729     fi
730
731     for OPTS in "${video_encoder_opts[@]}"; do 
732       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
733     done
734
735     if [ $audio_2ch -eq 0 ]; then
736       # These options produce good 6 channel audio for linux and windows
737       mencoder_audio_opts="-oac copy"
738       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
739       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
740       mencoder_audioch_opts[1]="-af channels=6"
741       mencoder_audioch_opts[2]=""
742     else
743       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
744       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
745       mencoder_audioch_opts[0]=""
746     fi
747  
748   fi
749
750   # iphone and ipod MP4 profiles
751   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
752     found_profile=1
753     if [ "$profile" == "iphone" ]; then
754       # SCALE: 480x320
755       # scale width to 480, set height appropriately, but keep a multiple of 16
756       #SCALE=",scale=480:-10"
757       # scale the video down however far is necessary to fit in 480x320
758       SCALE=",dsize=480:320:0,scale=-8:-8"
759     else
760       # SCALE: 320x240
761       # scale width to 320, set height appropriately, but keep a multiple of 16
762       #SCALE=",scale=320:-10"
763       # scale the video down however far is necessary to fit in 320x240
764       SCALE=",dsize=320:240:0,scale=-8:-8"
765     fi
766     final_output_file="$dest/$dvdname.mp4"
767     mencoder_general_opts="$lang_opts $passlogfile_opt"
768     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
769     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
770     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
771     video_encoder_opts[0]="bitrate=$target_bitrate"
772     video_encoder_opts[1]="threads=$mencoder_threads"
773     video_encoder_opts[2]="vbv_maxrate=1500"
774     video_encoder_opts[3]="vbv_bufsize=2000"
775     video_encoder_opts[4]="nocabac"
776     video_encoder_opts[5]="me=umh"
777     video_encoder_opts[6]="subq=6"
778     video_encoder_opts[7]="frameref=6"
779     video_encoder_opts[8]="trellis=1"
780     video_encoder_opts[9]="level_idc=30"
781     video_encoder_opts[10]="global_header"
782     video_encoder_opts[11]="bframes=0"
783     video_encoder_opts[12]="partitions=all"
784     for OPTS in "${video_encoder_opts[@]}"; do 
785       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
786     done
787
788     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
789     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
790   fi
791
792   if [ $found_profile -eq 0 ]; then
793     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
794   fi
795
796   # Do not edit this line. $mencoder_video_encoder_opts must be last
797   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
798   mencoder_retval=0
799
800   for PASS in $PASSES
801   do 
802     # Set some options based on which pass we are in
803     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
804     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
805     [ $PASS -eq 1 ] && output_file="/dev/null"
806     [ $PASS -eq 2 ] && output_file="$final_output_file"
807   
808     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
809     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
810     do
811       echo -e "   Encoding pass $PASS"
812       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
813       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
814       mencoder_retval=$? 
815       grep -q "\[channels\] Invalid" $encodelog
816       if [ $? != 0 ]; then          
817         break;
818       else
819         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
820       fi
821     done
822       
823     if [ $mencoder_retval != 0 ]; then
824       fatal_and_exit "-E- Unhandled mencoder error"
825     fi
826
827     # Concatenate the encode log to our main log file, greping out unwanted lines
828     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
829
830   done
831 }
832
833 function make_dvd_iso_image {
834
835   isofile="$1"
836
837   # check to see if we have a dvdpath to rip from instead of $dev
838   if [ -z "$dvdpath" ]; then
839     # load the CSS codes in the DVD drive 
840     lsdvd $dev >> "$logfile"
841     if [ $? != 0 ]; then
842       fatal_and_exit "-E- lsdvd $dev failed" 
843     fi
844
845     # read the DVD, ignoring/skipping CRC errors
846     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
847     if [ $? != 0 ]; then
848       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
849     fi
850     cat "$ddrescuelog" >> "$logfile"
851   else
852     # rip from a path instead
853     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
854   fi
855 }
856
857 function make_dvd_iso_image_from_folder {
858   
859   src="$1"
860   dst="$2"
861   handle_error=$3
862   
863   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
864
865   # make an iso image out of our directory
866   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
867   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
868
869   # set the audio languages from the iso if it exists and is non-zero in size
870   if [ -s "$dst" ]; then
871     get_feature_title "$dst"
872     get_audio_id_from_iso "$dst"
873   fi
874
875   # make sure we were able to create the iso image from the folder given to us
876   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
877     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
878     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
879     # remove the bad iso file
880     [[ -e "$dst" ]] && rm -f "$dst"
881     # get the feature title from the DVD folder
882     get_feature_title "$dvdpath"
883     # create our main VOB file from the ISO
884     create_main_vob_with_mplayer "$dvdpath" 
885     # get our audio id from the VOB file
886     get_audio_id_from_vob "$vobfile"
887   fi
888 }
889
890 function make_dvdbackup_folder_image {
891   # extract the feature title from the DVD image
892   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
893   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
894   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
895   if [ $? != 0 ]; then
896     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
897   fi
898 }
899
900 function make_dvdauthor_folder_image {
901   # create a new DVD video of the feature title
902   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
903   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
904   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
905   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
906
907   # There is a chance that dvdauthor won't like some of the VOBs.
908   # We can't tell ahead of time which ones it will choke on. 
909   # So, we need to run it over and over again until it can process
910   # all the VOBs. If it can't handle one of them, run it through
911   # mencoder to fix it and try again. These errors are typically
912   # present due to the copy protection that ddrescue removed.
913   grep -q "SCR moves" $dvdauthorlog
914   while [ $? == 0 ]; do
915     # fix bad vobs that get the "SCR moves backwards" error:
916     #  STAT: Processing VTS_01_0.VOB...
917     #  ERR:  SCR moves backwards, remultiplex input.
918     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
919     if [[ ! -f "$badvob" ]]; then
920       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
921     fi
922     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
923     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
924     mv -f $badvob.fixed $badvob
925     echo "-> Creating DVD video $dest/$dvdname"
926     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
927     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
928     grep -q "SCR moves" $dvdauthorlog
929   done
930 }
931
932 function get_feature_title {
933   source="$1"
934   # if a feature title was given on the command line, use it
935   if [ $feature_title_override -ne 0 ]; then
936     feature_title=$feature_title_override
937     return 0
938   fi
939   # otherwise, use lsdvd to figure it out
940   if [ $ripdvd -eq 1 ]; then
941     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
942   else 
943     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
944   fi
945 }
946
947 function create_main_vob_with_cat {
948   # cd to the feature title DVD folder
949   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
950   if [ $? != 0 ]; then
951     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
952   fi
953
954   # concatenate all the VOBs together into 1 giant VOB
955   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
956   cat $vobs > "$tmpdir/$dvdname.VOB"
957
958   # cd back to the dir we started from
959   popd > /dev/null 2>&1
960 }
961
962 function create_main_vob_with_mplayer {
963
964   # argument processing  
965   source="$1"
966   remove_dumplog=$2
967
968   # make sure we have a valid feature title
969   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
970     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
971   fi
972
973   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
974   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
975     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
976     msg="$msg We also detected another condition that requires us to use dumpstream. "
977     msg="$msg\n    Unable to rip this DVD in the mode you requested."
978     fatal_and_exit "$msg"
979   fi
980
981   # use mplayer to create the main VOB file
982   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
983   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
984   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
985   if [ $? != 0 ]; then
986     cat $dumplog | grep -v "^A:" >> "$logfile"
987     fatal_and_exit "-E- Mplayer Failed"
988   fi
989   cat $dumplog | grep -v "^A:" >> "$logfile"
990   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
991 }
992
993 function get_audio_id_from_iso {
994   # Adjust our audio ID to find the english audio stream
995   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
996   iso="$1"
997   aidcheck=`tempfile`
998   aid=$default_aid
999   alang=$default_alang
1000   if [ $aid_override -lt 0 ]; then 
1001     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1002     grep -q "aid: $aid" $aidcheck
1003     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1004       (( aid = aid + 1 ))
1005       grep -q "aid: $aid" $aidcheck
1006     done
1007     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1008   else
1009     aid=$aid_override
1010   fi
1011   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1012   # mencoder default DVD audio track language selection (english)
1013   lang_opts="-aid $aid -alang $alang"
1014 }
1015
1016 function get_crop_from_iso { 
1017   FRAMES=10000
1018   echo "-> Detecting black frame border crop value from ISO file"
1019   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1020   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1021   [[ -e "md5sums" ]] && rm -f "md5sums"
1022   CROP=`cat $dumplog | grep CROP | tail -1`
1023   echo "   Found crop value of $CROP" >> "$logfile"
1024   CROP=${CROP#* crop=}
1025   CROP=${CROP%%\).*}
1026   typeset -i CROPCHECK
1027   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1028   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1029   if [ -z "$CROP" ]; then
1030     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1031     return
1032   fi
1033   if [ $CROPCHECK -lt 0 ]; then 
1034     CROP=""
1035   else 
1036     CROP=",crop=$CROP"
1037   fi
1038   echo "   Setting mencoder crop filter to: $CROP"
1039 }
1040
1041 function get_crop_from_vob { 
1042   FRAMES=10000
1043   echo "-> Detecting black frame border crop value from VOB file"
1044   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1045   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1046   [[ -e "md5sums" ]] && rm -f "md5sums"
1047   CROP=`cat $dumplog | grep CROP | tail -1`
1048   echo "   Found crop value of $CROP" >> "$logfile"
1049   CROP=${CROP#* crop=}
1050   CROP=${CROP%%\).*}
1051   typeset -i CROPCHECK
1052   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1053   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1054   if [ -z "$CROP" ]; then
1055     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1056     return
1057   fi
1058   if [ $CROPCHECK -lt 0 ]; then 
1059     CROP=""
1060   else 
1061     CROP=",crop=$CROP"
1062   fi
1063   echo "   Setting mencoder crop filter to: $CROP"
1064 }
1065
1066 function get_audio_track_from_vob {
1067   # Adjust our audio ID to find the english audio stream
1068   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1069   vob="$1"
1070   handbrake_cli="$2"
1071   aidcheck=`tempfile`
1072   aid=$default_aid
1073   alang=$default_alang
1074   if [ $aid_override -lt 0 ]; then 
1075     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1076     grep -q "Found audio stream: $aid" $aidcheck
1077     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1078       (( aid = aid + 1 ))
1079       grep -q "Found audio stream: $aid" $aidcheck
1080     done
1081     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1082   else 
1083     aid=$aid_override
1084   fi
1085   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1086
1087   # convert the aid we found into hex
1088   aid_hex=`echo "obase=16; $aid" | bc`
1089   
1090   # extract the audio streams in the vob
1091   #ffmpeg -i "$vob" > $aidcheck 2>&1
1092   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1093   
1094   # find the stream that matches our aid
1095   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1096   #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1097   stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
1098  
1099   # extract the track number that handbrake uses
1100   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1101   track=`expr match "$stream" '^\([0-9]*\):'`
1102
1103   if [ -n "$track" ]; then   
1104     echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1105   fi
1106 }
1107
1108 function get_audio_id_from_vob {
1109   # Adjust our audio ID to find the english audio stream
1110   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1111   vob="$1"
1112   aidcheck=`tempfile`
1113   aid=$default_aid
1114   alang=$default_alang
1115   if [ $aid_override -lt 0 ]; then 
1116     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1117     grep -q "Found audio stream: $aid" $aidcheck
1118     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1119       (( aid = aid + 1 ))
1120       grep -q "Found audio stream: $aid" $aidcheck
1121     done
1122     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1123   else 
1124     aid=$aid_override
1125   fi
1126   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1127   # mencoder default DVD audio track language selection (english)
1128   lang_opts="-aid $aid -alang $alang"
1129 }
1130
1131 function check_vob_for_corrupted_start {
1132   # check to see if the beginning of the DVD has a form of copy protection
1133   # where they have deliberately broken the first X number of frames of the DVD.
1134   # If we don't skip these, our resulting VOB file will not play.
1135   badvobcheck=`tempfile`
1136   endpos=360
1137   skip=0
1138   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1139   if [ $? != 0 ]; then
1140     fatal_and_exit "-E- Mencoder Failed"
1141   fi
1142   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1143   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1144     (( skip = skip + 5 ))
1145     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1146     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1147     if [ $? != 0 ]; then
1148       fatal_and_exit "-E- Mencoder Failed"
1149     fi
1150     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1151   done
1152   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1153
1154   # cat the giant VOB into mencoder to create a playable VOB file
1155   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1156   if [ $? != 0 ]; then
1157     fatal_and_exit "-E- Mencoder Failed"
1158   fi
1159 }
1160
1161 function check_vob_for_completeness {
1162   # check to make sure we got out a complete VOB.
1163   # there is another kind of copy protection where the VOB's may
1164   # have "MPG EOF" frames in the middle of the stream. 
1165   # this causes mencoder to not process the entire VOB, and exit without any errors.
1166   # detect this by seeing how much smaller the dst vob is from the src vob.
1167   MAX_FILESIZE_DELTA_PERCENT=70
1168   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1169   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1170   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1171   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1172     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1173     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1174     create_main_vob_with_mplayer "$isofile"
1175     [[ -e "$dumplog" ]] && rm -f $dumplog
1176     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1177     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1178     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1179       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1180     fi
1181   fi
1182 }
1183
1184 function check_vob_for_too_many_video_packets {
1185   # If our earlier algorithm to work around this failed, throw an error.
1186   # check to see if this DVD has a protection scheme we don't know how to work around
1187   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1188   # for some reason, the video is black, while the audio rolls, then the video finally comes
1189   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1190   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1191   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1192   grep -q "Too many video packets in the buffer:" "$logfile"
1193   if [ $? == 0 ]; then
1194     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1195     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1196     create_main_vob_with_mplayer "$isofile"
1197     grep -q "Too many video packets in the buffer:" $dumplog
1198     if [ $? == 0 ]; then
1199       [[ -e "$dumplog" ]] && rm -f $dumplog
1200       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1201     fi
1202     [[ -e "$dumplog" ]] && rm -f $dumplog
1203   fi
1204 }
1205
1206 function check_vob_for_a52_crc_errors {
1207   # Let's see if we can playback our newly created VOB file without any errors.
1208   # if there are issues, let's detect them now, and try to recreate the VOB
1209   # there are some forms of copy protection that have missed above, that evidence
1210   # themselves when we try to playback the VOB file. This was added to deal with
1211   # the "a52: CRC check failed" copy protection scheme.
1212   MAX_ERRORS=10
1213   ENDPOS=120
1214   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1215   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1216   cat $dumplog | grep -v "^A:" >> "$logfile"
1217   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1218   if [ $errors -gt $MAX_ERRORS ]; then
1219     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1220     create_main_vob_with_mplayer "$isofile"
1221     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1222     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1223     if [ $? != 0 ]; then
1224       cat $dumplog | grep -v "^A:" >> "$logfile"
1225       fatal_and_exit "-E- Mplayer Failed"
1226     fi
1227     cat $dumplog | grep -v "^A:" >> "$logfile"
1228     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1229     if [ $errors -gt $MAX_ERRORS ]; then
1230       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1231     fi
1232   fi
1233   [[ -e "$dumplog" ]] && rm -f $dumplog
1234 }
1235
1236 function calculate_bitrate_from_target_size {
1237   # determine what our bitrate needs to be if a target size was specified instead
1238   if [ $target_size -ne 0 ]; then
1239     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1240     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1241     custom_bitrate=1
1242     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1243   fi
1244 }
1245
1246 function create_dvdauthor_dvd_xml_file {
1247   # make a dvdauthor xml menu file to create a valid DVD video from 
1248   # this script does a good job, but we'll still need to clean it up a bit after it runs
1249   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1250   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1251   if [ $? != 0 ]; then
1252     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1253   fi
1254
1255   # replace the first line of the xml file to remove the bad dest path
1256   awk -v line=1 -v new_content="<dvdauthor>" '{
1257     if (NR == line) {
1258       print new_content;
1259     } else {
1260       print $0;
1261     }
1262   }' dvd.xml > dvd.xml.new
1263   mv -f dvd.xml.new dvd.xml
1264   if [ $? != 0 ]; then
1265     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1266   fi
1267
1268   # remove the "<video " property line from the xml file
1269   cat dvd.xml | grep -v "<video" > dvd.xml.new
1270   mv -f dvd.xml.new dvd.xml
1271   if [ $? != 0 ]; then
1272     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1273   fi
1274   
1275   # remove the extra <pgc>..</pgc> pairs
1276   cat dvd.xml | awk 'BEGIN {x=1}
1277   {
1278     if ($0~"</pgc>") {x=0}
1279     if (x==1) {print $0}
1280     if ($0~"<pgc>") {x=1}
1281   }' > dvd.xml.new
1282   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1283   mv -f dvd.xml.new dvd.xml
1284   if [ $? != 0 ]; then
1285     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1286   fi
1287
1288   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1289   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1290   mv -f dvd.xml.new dvd.xml
1291   if [ $? != 0 ]; then
1292     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1293   fi
1294 }
1295
1296 function check_for_mplayer_dumpstream_incompatibility {
1297
1298   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1299
1300   if [ ! -e "$vobfile" ]; then
1301     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1302     # A DVD that has 99 titles, where the longest title isn't the main feature
1303     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1304     # out what the feature title is. This script will run through that flow if we
1305     # set use_mplayer_dumpstream to 0. Check for this here.
1306     if [ $ripdvd -eq 1 ]; then
1307       lsdvd $dev | grep -q "Title: 99"
1308     else
1309       lsdvd "$isofile" | grep -q "Title: 99"
1310     fi
1311     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1312     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1313       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1314         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1315         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1316         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1317         invalid_feature_title=1
1318       else 
1319         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1320         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1321         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1322         use_mplayer_dumpstream=0
1323         invalid_feature_title=1
1324       fi
1325       return
1326     fi
1327   fi
1328
1329   # There is another form of protection that causes the mplayer dumpstream to fail. 
1330   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1331   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1332   # problem before continuing.
1333   if [ -e "$vobfile" ]; then
1334     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1335     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1336     grep -q "Too many audio packets in the buffer" $dumplog
1337     if [ $? == 0 ]; then
1338       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1339       use_mplayer_dumpstream=0
1340       mplayer_dumpstream_incompatibility=1
1341     fi
1342     [[ -e "$dumplog" ]] && rm -f $dumplog
1343   fi
1344 }
1345
1346 function fill_mythvideo_metadata {
1347
1348   # This function must be passed the filename as an argument
1349   # The filename must be a full path to the file
1350   filename="$1"
1351
1352   # Make sure the fill mythvideo metadata option has been set to 1
1353   if [ $fill_mythvideo_metadata -eq 0 ]; then
1354     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1355     return 0
1356   fi
1357
1358   # If the fill mythvideo metadata script is present, run it
1359   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1360   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1361     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1362     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1363   else
1364     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1365     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1366   fi
1367 }
1368
1369 # remove the intermediate VOB file
1370 function remove_intermediate_vob_file {
1371   if [ $keep_intermediate_files -eq 0 ]; then
1372     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1373   else
1374     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1375   fi
1376 }
1377
1378 # remove the original DVD image 
1379 function remove_intermediate_iso_file {
1380   [[ $keep_isofile -eq 1 ]] && return 1
1381   if [ $keep_intermediate_files -eq 0 ]; then
1382     [[ -e "$isofile" ]] && rm "$isofile"
1383   else
1384     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1385   fi
1386 }
1387
1388 # remove the intermediate dvdbackup folder
1389 function remove_intermediate_dvdbackup_folder {
1390   if [ $keep_intermediate_files -eq 0 ]; then
1391     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1392   else
1393     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1394   fi
1395 }
1396
1397 ##############################################################################################
1398 # MAIN
1399 ##############################################################################################
1400
1401 # Make a note of when this DVD rip started
1402 date=`date`
1403 echo -e "\n$date DVD rip started" >> "$logfile"
1404 echo "$cmd" >> "$logfile"
1405
1406 # Rip the DVD - Mirror Mode
1407 if [ $mirror_mode -eq 1 ]; then
1408   echo "-> Ripping DVD $dvdname to $dest"
1409
1410   # use ddrescue to make an ISO image of the disk
1411   make_dvd_iso_image "$dest/$dvdname.iso"
1412
1413   # add this video data to the mythtv DB
1414   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1415
1416   # eject the disk upon completion
1417   if [ $eject_disk -ne 0 ]; then
1418     eject -T $dev
1419   fi
1420
1421   date=`date`
1422   echo "$date DVD rip completed" | tee -a "$logfile"
1423
1424   if [[ -n "$mailto" ]]; then
1425     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1426   fi
1427
1428 fi
1429
1430 # Rip the DVD - Main Title Feature Only
1431 if [ $mirror_mode -eq 0 ]; then
1432
1433   # Rip image from DVD
1434   if [ $ripdvd -eq 1 ]; then
1435     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1436     # use ddrescue to make an ISO image of the disk
1437     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1438   fi
1439
1440   # Rip image from DVD path
1441   if [ -n "$dvdpath" ]; then
1442     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1443     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1444   fi
1445
1446   # make sure our isofile value is set
1447   if [ -z "$isofile" ]; then
1448     isofile="$tmpdir/$dvdname.iso"
1449   fi
1450      
1451   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1452
1453     if [ ! -e "$vobfile" ]; then
1454       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1455       
1456       # get the feature title from the ISO
1457       get_feature_title "$isofile"
1458  
1459       # get the crop value from the ISO
1460       get_crop_from_iso
1461
1462       # check for mplayer dumpstream incompatibilities
1463       # if they exist, this method will set this mode to 0.
1464       check_for_mplayer_dumpstream_incompatibility
1465
1466       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1467
1468         # get our audio id from the ISO file
1469         get_audio_id_from_iso "$isofile"
1470
1471         # create our main VOB file from the ISO
1472         create_main_vob_with_mplayer "$isofile"
1473      
1474         # remove the intermediate VOB file
1475         remove_intermediate_vob_file
1476
1477         # it's possible that our VOB is still corrupted in some manner
1478         # check to make sure it is still a good VOB before continuing.
1479         check_for_mplayer_dumpstream_incompatibility
1480
1481       fi
1482  
1483       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1484
1485         # use dvdbackup to make a DVD folder of the feature title
1486         make_dvdbackup_folder_image
1487   
1488         # create our main VOB file
1489         create_main_vob_with_cat
1490
1491         # get our audio id from the VOB file
1492         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1493   
1494         # check for corrupted VOB start
1495         check_vob_for_corrupted_start
1496  
1497         # check to make sure our VOB is complete
1498         check_vob_for_completeness
1499
1500         # check to make sure our VOB doesn't have too many video packets
1501         check_vob_for_too_many_video_packets
1502
1503         # check to make sure our VOB doesn't have a52 crc errors
1504         check_vob_for_a52_crc_errors
1505
1506         # remove the intermediate VOB file
1507         remove_intermediate_vob_file
1508
1509       fi
1510
1511       # remove the intermediate ISO file
1512       remove_intermediate_iso_file
1513
1514     else
1515       if [ "$encoder" != "handbrake" ]; then 
1516         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1517         # get our audio id from the VOB file
1518         get_audio_id_from_vob "$vobfile"
1519         # get the crop value from the VOB
1520         get_crop_from_vob
1521       fi
1522     fi
1523
1524     # eject the DVD disk since we are finished with it
1525     [ $eject_disk -eq 2 ] && eject -T $dev
1526
1527     # encode the VOB file to a compressed file format
1528     if [ $make_final_dest_comp -eq 1 ]; then
1529       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1530
1531       # determine what our bitrate needs to be if a target size was specified instead
1532       calculate_bitrate_from_target_size        
1533      
1534       # encode the vob file into a compressed file format
1535       if [[ "$encoder" == "mencoder" ]]; then 
1536         encode_vob_file_mencoder
1537       fi
1538       if [[ "$encoder" == "handbrake" ]]; then
1539         encode_vob_file_handbrake
1540       fi
1541
1542       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1543         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1544         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1545       else
1546         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1547         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1548       fi
1549     fi
1550
1551   # add this video data to the mythtv DB
1552   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1553   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1554     
1555   else
1556
1557   # use dvdbackup to make a DVD folder of the feature title
1558   make_dvdbackup_folder_image
1559
1560   # cd to the feature title DVD folder
1561   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1562   if [ $? != 0 ]; then
1563     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1564   fi
1565   
1566   # create the dvd.xml file for dvdauthor
1567   create_dvdauthor_dvd_xml_file  
1568
1569   # make the final DVD folder image
1570   make_dvdauthor_folder_image
1571
1572   # add this video data to the mythtv DB
1573   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1574  
1575   # cd back to the dir we started from
1576   popd > /dev/null 2>&1
1577
1578   if [ $make_final_dest_iso -eq 1 ]; then
1579
1580     # make an iso image out of our directory
1581     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1582    
1583     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1584     if [ -s "$dest/$dvdname.iso" ]; then
1585       if [ $make_final_dest_folder -eq 0 ]; then
1586         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1587         # remove the folder of the DVD image now that we have a .iso version of it
1588         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1589       fi
1590     else
1591       # we created an empty iso file, remove it
1592       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1593       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1594       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1595     fi
1596  
1597     # add this video data to the mythtv DB
1598     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1599
1600   fi
1601
1602   fi
1603
1604   # remove the ddrescue DVD ISO image
1605   remove_intermediate_iso_file
1606
1607   # remove the tmp dvdbackup folder of the DVD image
1608   remove_intermediate_dvdbackup_folder
1609
1610   # eject the DVD disk upon completion
1611   [ $eject_disk -eq 1 ] && eject -T $dev
1612
1613   date=`date`
1614   echo "$date DVD rip completed" | tee -a "$logfile"
1615
1616   if [[ -n "$mailto" ]]; then
1617     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1618   fi
1619
1620 fi
1621
1622 ##############################################################################################